package cn.edu.sdu.virion.feature.selection;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

import cn.edu.sdu.virion.support.database.DBHelper;
import cn.edu.sdu.virion.support.weka.Classify;
import weka.classifiers.Classifier;
import weka.classifiers.trees.RandomForest;
import weka.core.Instances;
import weka.core.SerializationHelper;
import weka.core.Utils;
import weka.filters.Filter;
import weka.filters.unsupervised.attribute.Remove;

public class CTD extends BaseSelection{

	protected String featureSourceTable;
	private String attrTypeName;
	private int CFeatureNum;
	private int TFeatureNum;
	private int DFeatureNum;
	private int featuresNum;
	private int seqclassIndex;
	private int attributeStartIndex;
	private int selected_attr_num;
	private int selected_num_trees;
	private int selected_num_features;
	
	/**
	 * 캯
	 */
	public CTD()
	{
		CFeatureNum = 10;
		TFeatureNum = 45;
		DFeatureNum = 50;
		featuresNum = CFeatureNum + TFeatureNum + DFeatureNum;
		featureSourceTable = "CDHIT_SEQS_6";
		attrTypeName = "CTD";
		seqclassIndex = 2;
		attributeStartIndex = 13;
		
		this.selected_attr_num = 79;
		this.selected_num_trees = 30;
		this.selected_num_features = 10;
	}
	
	/**
	 * ¼¼
	 */
	public void generateInsertSQL()
	{
		List<String> list = new ArrayList<String>();
		list.addAll(attrNameList("Composition_", 1, CFeatureNum));
		list.addAll(attrNameList("Transition_", 1, TFeatureNum));
		list.addAll(attrNameList("Distribution_", 1, DFeatureNum));
		for (String name : list) 
			System.out.println(String.format(insertTemplate, attrTypeName, name));
	}
	
	/**
	 * Ȩ
	 */
	public void updateWeight() {
		try {
			super.updateWeight(featureSourceTable, seqclassIndex,
					attributeStartIndex, featuresNum);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void attributeSelectionAll() throws SQLException {
		OneByOne(attrTypeName, 1, featuresNum, featureSourceTable,
				seqclassIndex);
	}
	
	public void test_A() throws Exception {
		super.test(featureSourceTable, featuresNum, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_1_A");
	}
	
	public void test() throws Exception {
		super.test(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_1");
	}
	
	public void testAll() throws Exception {
		super.testAll(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_1");
	}
	
	/**
	 * ģļ
	 * @throws Exception
	 */
	public void generateModelFile() throws Exception {
		super.generateModelFile(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features);
	}
	
	/**
	 * ģͲύ
	 * @param jobid
	 * @throws Exception
	 */
	public void testWebSeqsUseModel(String jobid) throws Exception {
		super.testWebSeqsUseModel(jobid, selected_attr_num, attrTypeName, seqclassIndex, "SCORE_1");
	}
	
	public void getSelectedFeaturesSql() throws Exception {
		super.getSelectedFeaturesSql(featureSourceTable, selected_attr_num, attrTypeName);
	}
	
	public String getSelectedFeaturesStr() throws SQLException {
		return super.getSelectedFeaturesStr(this.selected_attr_num, this.attrTypeName);
	}
}
