package cn.edu.sdu.virion.support.network;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;
import java.net.URLConnection;
import java.util.List;
import java.util.Map;

public class HttpRequest {
    /**
     * ָURLGET
     * 
     * @param url
     *            URL
     * @param param
     *            Ӧ name1=value1&name2=value2 ʽ
     * @return URL ԶԴӦ
     */
    public static String sendGet(String url, String param) {
        String result = "";
        BufferedReader in = null;
        try {
            String urlNameString = url + "?" + param;
            URL realUrl = new URL(urlNameString);
            // 򿪺URL֮
            URLConnection connection = realUrl.openConnection();
            // ͨõ
            connection.setRequestProperty("accept", "*/*");
            connection.setRequestProperty("connection", "Keep-Alive");
            connection.setRequestProperty("user-agent",
                    "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            // ʵʵ
            connection.connect();
            // ȡӦͷֶ
            Map<String, List<String>> map = connection.getHeaderFields();
            // еӦͷֶ
            for (String key : map.keySet()) {
                System.out.println(key + "--->" + map.get(key));
            }
            //  BufferedReaderȡURLӦ
            in = new BufferedReader(new InputStreamReader(
                    connection.getInputStream()));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
        } catch (Exception e) {
            System.out.println("GET쳣" + e);
            e.printStackTrace();
        }
        // ʹfinallyر
        finally {
            try {
                if (in != null) {
                    in.close();
                }
            } catch (Exception e2) {
                e2.printStackTrace();
            }
        }
        return result;
    }

    /**
     * ָ URL POST
     * 
     * @param url
     *             URL
     * @param param
     *            Ӧ name1=value1&name2=value2 ʽ
     * @return ԶԴӦ
     */
    public static String sendPost(String url, String param) {
        PrintWriter out = null;
        BufferedReader in = null;
        String result = "";
        try {
            URL realUrl = new URL(url);
            // 򿪺URL֮
            URLConnection conn = realUrl.openConnection();
            // ͨõ
            conn.setRequestProperty("accept", "*/*");
            conn.setRequestProperty("connection", "Keep-Alive");
            conn.setRequestProperty("user-agent",
                    "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            // POST
            conn.setDoOutput(true);
            conn.setDoInput(true);
            // ȡURLConnectionӦ
            out = new PrintWriter(conn.getOutputStream());
            // 
            out.print(param);
            // flushĻ
            out.flush();
            // BufferedReaderȡURLӦ
            in = new BufferedReader(
                    new InputStreamReader(conn.getInputStream()));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
        } catch (Exception e) {
            System.out.println(" POST 쳣"+e);
//            e.printStackTrace();
        }
        //ʹfinallyر
        finally{
            try{
                if(out!=null){
                    out.close();
                }
                if(in!=null){
                    in.close();
                }
            }
            catch(IOException ex){
                ex.printStackTrace();
            }
        }
        return result;
    }    
}